#include "stk.h"
#include "names.h"


int stk_nr_forms;
stkForm *stk_forms_head;	// pointer to first form


stkForm *stkCreateForm( int x, int y, int w, int h ){
	stkForm *form;

printf("stkCreateForm(): creating form @ (%d,%d)\n", x,y);

	form = (stkForm *)malloc(sizeof(stkForm));
	if(form != NULL){
		form->flags = (char)STK_FLAGS_VISIBLE; // not enabled
		form->x = x;
		form->y = y;
		form->w = w;
		form->h = h;
		form->max_objects = OBJECTS_PER_BLOCK;
		form->nr_objects = 0;
		form->objects = (stkObject **)malloc(sizeof(stkObject *)*OBJECTS_PER_BLOCK);

		if(stk_forms_head == NULL){
			stk_forms_head = form;
			form->next = NULL;
		} else {
			stk_forms_head->prev = form;
			form->next = stk_forms_head;
			stk_forms_head = form;
		}
		form->prev = NULL;
		stk_nr_forms++;
	}
	return(form);
}


void stkFreeForm( stkForm *form ){
	stkObject *object;

	if(form == NULL) return;

	while(form->nr_objects){
		form->nr_objects--;
		object = form->objects[form->nr_objects];
		switch(object->type){
			case STK_BUTTON:
				free(object->BUTTON_TITLE);
				break;
			case STK_TOGGLE_BUTTON:
				free(object->TOGGLE_UPTITLE);
				free(object->TOGGLE_DOWNTITLE);
				break;
			case STK_INPUT:
				free(object->INPUT_TEXT);
				break;
			case STK_VIEWGL:
				glutDestroyWindow(object->VIEWGL_WINDOW);
				break;
			case STK_LABEL:
				free(object->LABEL_TITLE);
				break;
		}
		free(object->v);
		free(object);
	}
	if(form == stk_forms_head) stk_forms_head = form->next;
	if(form->next) form->next->prev = form->prev;
	if(form->prev) form->prev->next = form->next;
	free(form->objects);
	free(form);
	stk_nr_forms--;
}


void stkShowForm( stkForm *form ){
	if(form == NULL) return;

	form->flags |= (char)STK_FLAGS_VISIBLE;
}


void stkHideForm( stkForm *form ){
	if(form == NULL) return;

	form->flags &= (char)(~STK_FLAGS_VISIBLE);
}


void stkEnableForm( stkForm *form ){
	if(form == NULL) return;

	form->flags |= (char)STK_FLAGS_ENABLED;
}


void stkDisableForm( stkForm *form ){
	if(form == NULL) return;

	form->flags &= (char)(~STK_FLAGS_ENABLED);
}
