#include "stk.h"
#include "names.h"


int stk_mouse_x, stk_mouse_y;
int stk_mouse_button, stk_mouse_state;
stkObject *stk_mouse_over_object;


stkObject *stkIsOverObject( int x, int y ){
	stkObject *object;
	stkForm *form;
	int f, o;

	f = stk_nr_forms;
	form = stk_forms_head;
	while(f){
		if(form->flags & STK_FLAGS_ENABLED){
		 if(x>(form->x) && x<(form->x + form->w)){
		  if(y>(form->y) && y<(form->y + form->h)){
			o = form->nr_objects;
			while(o){
				o--;
				object = form->objects[o];
				if(object->flags & STK_FLAGS_ENABLED){
				 if(x>(object->x) && x<(object->x + object->w)){
				  if(y>(object->y) && y<(object->y + object->h)) return(object);
				 }
				}
			}
		  }
		 }
		}
		f--;
		form = form->next;
	}
	return(NULL);
}


void stkMouseButton( int button, int state, int x, int y ){
	// button pressed or released
	stkObject *object;

	x = x/stk_window_wr;
	y = (stk_window_h - 1 - y)/stk_window_hr;

	stkRenderBegin();

	if((object = stkIsOverObject(x, y)) != NULL){
	  if(stk_mouse_over_object != object){
		stkRenderObject[stk_mouse_over_object->type](stk_mouse_over_object, 0);
	  }
	  if(object->type == STK_VIEW){
		if(object->VIEW_MOUSEBUTTON != NULL)
			(object->VIEW_MOUSEBUTTON)(button, state, x - object->x, y - object->y);
	  } else if(state == GLUT_DOWN){
		if(button == GLUT_LEFT_BUTTON){
		  stk_mouse_button = 1;
		  switch(object->type){
			case STK_BUTTON:
				object->flags |= (char)STK_FLAGS_BUTTON_PRESSED;
				if(object->BUTTON_PRESS != NULL) (object->BUTTON_PRESS)();
				break;
			case STK_TOGGLE_BUTTON:
				object->TOGGLE_STATE++;
				if(object->TOGGLE_STATE > 1)
					object->TOGGLE_STATE = 0;
				if(object->TOGGLE_PRESS != NULL)
					(object->TOGGLE_PRESS)(object->TOGGLE_STATE);
				break;
			case STK_INPUT:
				if(stk_input_with_focus != object){
				  stk_input_with_focus = object;
				  stk_input_left = 0;
				  stk_input_cursor = 0;
				  stk_input_highlight = 0;

					// when entering box the text should be highlighted
					// and cursor should be placed at the end

				} else {

					// find x within box
					// add up char widths until greater than x

				}
				break;
			case STK_HSCROLLBAR:
				break;
			case STK_VSCROLLBAR:
				break;
			case STK_CHECKBOX:
				object->CHECKBOX_STATE++;
				if(object->CHECKBOX_STATE > 1)
					object->CHECKBOX_STATE = 0;
				if(object->CHECKBOX_CHANGE != NULL)
					(object->CHECKBOX_CHANGE)(object->CHECKBOX_STATE);
				break;
		  }
		}

		stkRenderObject[object->type](object, 1);
		stk_mouse_over_object = object;
	  } else if((state == GLUT_UP) && (button == GLUT_LEFT_BUTTON)){
		switch(object->type){
			case STK_BUTTON:
				object->flags &= (char)(~STK_FLAGS_BUTTON_PRESSED);
				break;
			case STK_HSCROLLBAR:
				break;
			case STK_VSCROLLBAR:
				break;
		}
		stk_mouse_button = 0;
		stkRenderObject[object->type](object, 1);
	  }
	} else if(stk_mouse_over_object){
		stkRenderObject[stk_mouse_over_object->type](stk_mouse_over_object, 0);
		stk_mouse_over_object = NULL;
	}

	stkRenderEnd();
}


void stkMouseActive( int x, int y ){
	// mouse motion with one or more buttons down
	stkObject *object;

	x = x/stk_window_wr;      
	y = (stk_window_h - 1 - y)/stk_window_hr;

	if((object = stkIsOverObject(x, y)) != NULL){
	  if(stk_mouse_over_object == object){
		stkRenderBegin();

		if(object->type == STK_VIEW){
			if(object->VIEW_MOUSEMOTION != NULL)
				(object->VIEW_MOUSEMOTION)(x - object->x, y - object->y);
		} else if(stk_mouse_button){
			switch(object->type){
				case STK_INPUT:
printf("## drag from input object\n");


					// set stk_input_left if cursor moves left or right outside box
					// set stk_input_highlight for current character


					break;
				case STK_HSCROLLBAR:
printf("## drag from hscrollbar object\n");
					break;
				case STK_VSCROLLBAR:
printf("## drag from vscrollbar object\n");
					break;
			}
			stkRenderObject[object->type](object, 1);
		}

		stkRenderEnd();
	  }
	}
}


void stkMousePassive( int x, int y ){
	// mouse motion with all buttons released
	stkObject *object;

	stk_mouse_x = x = x/stk_window_wr;      
	stk_mouse_y = y = (stk_window_h - 1 - y)/stk_window_hr;

	if((object = stkIsOverObject(x, y)) != NULL){
		if((stk_mouse_over_object != object) && (object->type != STK_VIEW)){
			stkRenderBegin();

			if(stk_mouse_over_object != NULL)
				stkRenderObject[stk_mouse_over_object->type](stk_mouse_over_object, 0);
			stkRenderObject[object->type](object, 1);
			stk_mouse_over_object = object;

			stkRenderEnd();
		}
	} else {
		if(stk_mouse_over_object != NULL){
			stkRenderBegin();

			stkRenderObject[stk_mouse_over_object->type](stk_mouse_over_object, 0);
			stk_mouse_over_object = NULL;

			stkRenderEnd();
		}
	}
}


void stkMouseEntry( int state ){
	if(state == GLUT_LEFT){
		if(stk_mouse_over_object != NULL){
			stkRenderBegin();

			stkRenderObject[stk_mouse_over_object->type](stk_mouse_over_object, 0);
			stk_mouse_over_object = NULL;

			stkRenderEnd();
		}
	}
}
