#include "stk.h"
#include "names.h"


stkObject *stkCreateViewGL( stkForm *form, int x, int y, int w, int h,
				void (*redraw)(),
				void (*resize)(int width, int height),
				int *window ){
	stkObject *object;

	object = stkCreateObject(STK_VIEWGL, form, x,y,w,h, __VIEWGL_SIZE);
	if(object != NULL){
		object->VIEWGL_WINDOW = glutCreateSubWindow(stk_window,
				(int)(x*stk_window_wr) + 1,
				(int)((stk_window_oh - 1 - y - h)*stk_window_hr) + 1,
				(int)(w*stk_window_wr) - 2, (int)(h*stk_window_hr) - 2 );
		object->VIEWGL_RESIZE = resize;

		if(object->VIEWGL_WINDOW == GL_FALSE){
			form->nr_objects--;
			free(object);
			return(NULL);
		}

		*window = object->VIEWGL_WINDOW;
		glutDisplayFunc(redraw);
		glutReshapeFunc(resize);
		if(resize != NULL) resize((int)(w*stk_window_wr) -2, (int)(h*stk_window_hr) -2);
		glutSetWindow(stk_window);
		form->flags |= (char)STK_FLAGS_FORM_HAS_VIEW;
	}
	return(object);
}


stkObject *stkCreateView( stkForm *form, int x, int y, int w, int h,
			void (*redraw)(),
			void (*key_press)(int state, char ascii),
			void (*mouse_button)(int button, int state, int x, int y),
			void (*mouse_motion)(int x, int y) ){
	stkObject *object;

	object = stkCreateObject(STK_VIEW, form, x,y,w,h, __VIEW_SIZE);
	if(object != NULL){
		object->VIEW_REDRAW = redraw;
		object->VIEW_KEYPRESS = key_press;
		object->VIEW_MOUSEBUTTON = mouse_button;
		object->VIEW_MOUSEMOTION = mouse_motion;
	}
	return(object);
}


